//+------------------------------------------------------------------+
//|                                       Price and Volume Trend.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrSilver
#property indicator_color3  clrPaleVioletRed
#property indicator_color4  clrSilver
#property indicator_color5  clrLimeGreen
#property indicator_color6  clrLimeGreen
#property indicator_color7  clrRed
#property indicator_color8  clrRed
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_width8  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property strict

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i,double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i,double precision);
#import

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};
enum enColorOn
{
   clr_onOut,  // Change color on outer levels cross
   clr_onZer   // Change color on zero cross
};
enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};

extern enTimeFrames TimeFrame       = tf_cu;       // Time frame
extern int          TimeFrameCustom = 0;           // Custom time frame to use (if custom time frame used)
extern enPrices     PvtAppliedPrice = pr_weighted; // Price to use
extern double       LevelUp         = 90;          // Level up (%)
extern double       LevelDown       = 10;          // Level down (%)
extern int          LookBackBars    = 75;          // Look back bars no
extern enColorOn    ColorOn         = clr_onOut;   // Change color on :
extern bool         Interpolate     = true;             // Interpolate in multi time frame mode?

double pvt[],pvtda[],pvtdb[],pvtua[],pvtub[],dzup[],dzmi[],dzdn[],prices[],state[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
   IndicatorBuffers(10);
      SetIndexBuffer(0, dzup);
      SetIndexBuffer(1, dzmi);
      SetIndexBuffer(2, dzdn);
      SetIndexBuffer(3, pvt);
      SetIndexBuffer(4, pvtua);
      SetIndexBuffer(5, pvtub);
      SetIndexBuffer(6, pvtda);
      SetIndexBuffer(7, pvtdb);
      SetIndexBuffer(8, prices);
      SetIndexBuffer(9, state);
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99; 
      if (TimeFrameCustom==0) TimeFrameCustom = MathMax(TimeFrameCustom,_Period);
      if (TimeFrame!=tf_cus)
            TimeFrame = MathMax(TimeFrame,_Period);
      else  TimeFrame = (enTimeFrames)TimeFrameCustom;
      
   IndicatorShortName(timeFrameToString(TimeFrame)+" Price and Volume Trend");
return(0);
}

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { dzup[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
   
      if (state[limit]== 1) CleanPoint(limit,pvtua,pvtub);
      if (state[limit]==-1) CleanPoint(limit,pvtda,pvtdb);
      for (i= limit; i >= 0; i--) 
      {
         prices[i] = getPrice(PvtAppliedPrice,Open,Close,High,Low,i);
         if(i == Bars - 1) { pvt[i] = (double)Volume[i]; continue; }
      
         //
         //
         //
         //
         //
      
         state[i] = 0;
         pvt[i]   = pvt[i+1] + Volume[i]*(prices[i]-prices[i+1])/prices[i+1];  
         dzup[i]  = dzBuyP (pvt,  LevelUp  /100,LookBackBars,Bars,i,0.1);
         dzdn[i]  = dzSellP(pvt,1-LevelDown/100,LookBackBars,Bars,i,0.1);
         dzmi[i]  = dzBuyP (pvt,            0.5,LookBackBars,Bars,i,0.1);
         pvtua[i] = EMPTY_VALUE;
         pvtub[i] = EMPTY_VALUE;
         pvtda[i] = EMPTY_VALUE;
         pvtdb[i] = EMPTY_VALUE;
         if (ColorOn==clr_onOut)
         {
            if (pvt[i]<dzdn[i]) state[i] = -1;
            if (pvt[i]>dzup[i]) state[i] =  1;
         }
         else
         {
            if (pvt[i]<dzmi[i]) state[i] = -1;
            if (pvt[i]>dzmi[i]) state[i] =  1;
         }         
         if (state[i] == 1) PlotPoint(i,pvtua,pvtub,pvt);
         if (state[i] ==-1) PlotPoint(i,pvtda,pvtdb,pvt);
   }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (state[limit]== 1) CleanPoint(limit,pvtua,pvtub);
   if (state[limit]==-1) CleanPoint(limit,pvtda,pvtdb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         dzup[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,PvtAppliedPrice,LevelUp,LevelDown,LookBackBars,ColorOn,0,y);
         dzmi[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,PvtAppliedPrice,LevelUp,LevelDown,LookBackBars,ColorOn,1,y);
         dzdn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,PvtAppliedPrice,LevelUp,LevelDown,LookBackBars,ColorOn,2,y);
         pvt[i]   = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,PvtAppliedPrice,LevelUp,LevelDown,LookBackBars,ColorOn,3,y);
         state[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,PvtAppliedPrice,LevelUp,LevelDown,LookBackBars,ColorOn,9,y);
         pvtua[i] = EMPTY_VALUE;
         pvtub[i] = EMPTY_VALUE;
         pvtda[i] = EMPTY_VALUE;
         pvtdb[i] = EMPTY_VALUE;
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         //
         //
         //
         //
         //

         int n,k; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(k = 1; i+n < Bars && i+k < Bars && k < n; k++) 
            {
               dzup[i+k] = dzup[i] + (dzup[i+n] - dzup[i])* k/n;
               dzmi[i+k] = dzmi[i] + (dzmi[i+n] - dzmi[i])* k/n;
               dzdn[i+k] = dzdn[i] + (dzdn[i+n] - dzdn[i])* k/n;
               pvt[i+k]  = pvt[i]  + (pvt[i+n]  - pvt[i]) * k/n;
            }               
   }
   for (i= limit; i >= 0; i--) 
   {
      if (state[i] == 1) PlotPoint(i,pvtua,pvtub,pvt);
      if (state[i] ==-1) PlotPoint(i,pvtda,pvtdb,pvt);
   }
return(0);         
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=4;
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i];  second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}